; 
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm

    ;----------------
    ; This by drizz.
    ;----------------

    AbsEAX macro
      cdq
      xor eax,edx
      sub eax,edx
    endm

; 
    .data
      error     dq 0
      sqrt_tbl  dd 0
      sqrt      dd 0
    .code
; 

InitTable proc

    mov sqrt_tbl, alloc(1024+100)

    ; table function 256.0 * sqrt( i/256.0 );

    mov ecx,256
    xor edx,edx
  @@:
    push ecx
    push edx
    fild dword ptr[esp]
    push 256
    fidiv dword ptr[esp]
    fsqrt
    push 256
    fimul dword ptr[esp]
    fistp dword ptr[esp]
    pop sqrt
    pop edx
    pop edx

    push sqrt
    pop ecx

    mov [eax+edx],cl

    pop ecx
    inc edx
    dec ecx
    jns @b
    ret
InitTable endp

; 

align 4
UMGetSqrt proc uses esi value:dword

   ; Gem writers: Arne Steinarson

      mov eax,value
      mov esi,sqrt_tbl

        cmp     eax,10000h
        jb      c_15_0
        cmp     eax,1000000h
        jb      c_23_16

; bit 31..24
        cmp     eax,10000000h
        jb      c_27_24
        cmp     eax,40000000h
        jb      c_29_28
        shr     eax,24
        mov     al, [esi+eax]
        shl     eax,8
        ret
c_29_28:
        shr     eax,22
        mov     al, [esi+eax]
        shl     eax,7
        ret
c_27_24:
        cmp     eax,4000000h
        jb      c_25_24
        shr     eax,20
        mov     al, [esi+eax]
        shl     eax,6
        ret
c_25_24:
        shr     eax,18
        mov     al, [esi+eax]
        shl     eax,5
        ret

; bit 23..16
c_23_16:
        cmp     eax,100000h
        jb      c_19_16
        cmp     eax,400000h
        jb      c_21_20
        shr     eax,16
        mov     al, [esi+eax]
        shl     eax,4
        ret
c_21_20:
        shr     eax,14
        mov     al, [esi+eax]
        shl     eax,3
        ret
c_19_16:
        cmp     eax,40000h
        jb      c_17_16
        shr     eax,12
        mov     al, [esi+eax]
        shl     eax,2
        ret
c_17_16:
        shr     eax,10
        mov     al, [esi+eax]
        shl     eax,1
        ret

c_15_0: cmp     eax,100h
        jb      c_7_0

; bit 15..8
        cmp     eax,1000h
        jb      c_11_8
        cmp     eax,4000h
        jb      c_13_12
        shr     eax,8
        mov     al, [esi+eax]
        ret
c_13_12:
        shr     eax,6
        mov     al, [esi+eax]
        shr     eax,1
        ret
c_11_8: cmp     eax,400h
        jb      c_9_8
        shr     eax,4
        mov     al, [esi+eax]
        shr     eax,2
        ret
c_9_8:  shr     eax,2
        mov     al, [esi+eax]
        shr     eax,3
        ret

;bit 7..0
c_7_0:  cmp     eax,10h
        jb      c_3_0
        cmp     eax,40h
        jb      c_5_4
        mov     al, [esi+eax]
        shr     eax,4
        ret
c_5_4:  shl     eax,2
        mov     al, [esi+eax]
        shr     eax,5
        ret
c_3_0:  cmp     eax,4h
        jb      c_1_0
        shl     eax,4
        mov     al, [esi+eax]
        shr     eax,6
        ret
c_1_0:  shl     eax,6
        mov     al, [esi+eax]
        shr     eax,7
        ret

UMGetSqrt endp

; 
align 4
fisqrt proc arg:DWORD
    fild  arg
    fsqrt
    push  eax
    fistp DWORD PTR [esp]
    pop   eax
    ret
fisqrt endp

; 
start:
; 
    invoke InitTable

    xor ebx, ebx
    .WHILE ebx < 100
      invoke nrandom,1000
      mov esi, eax
      print ustr$(esi)
      loc 15, ebx
      invoke UMGetSqrt, esi
      print ustr$(eax)
      loc 25, ebx
      invoke fisqrt, esi
      print ustr$(eax),13,10
      inc ebx
    .ENDW

    .WHILE ebx < 200
      invoke nrandom,4000000000
      mov esi, eax
      print ustr$(esi)
      loc 15, ebx
      invoke UMGetSqrt, esi
      print ustr$(eax)
      loc 25, ebx
      invoke fisqrt, esi
      print ustr$(eax),13,10
      inc ebx
    .ENDW

    print chr$(13,10)
    inkey
    print chr$(13,10)

    xor esi, esi
    xor ebx, ebx
    .WHILE ebx < 1000
      invoke UMGetSqrt, ebx
      push eax
      invoke fisqrt, ebx
      pop edx
      sub eax, edx
      AbsEAX
      add esi, eax
      inc ebx
    .ENDW
    push esi
    fild DWORD PTR [esp]
    fld8 1000.0
    fdiv
    fstp error
    pop eax
    invoke crt_printf, chr$("mean absolute error 0-999: %f%c%c"),
                       error, 10, 10

    xor esi, esi
    xor ebx, ebx
    .WHILE ebx < 1000000
      invoke UMGetSqrt, ebx
      push eax
      invoke fisqrt, ebx
      pop edx
      sub eax, edx
      AbsEAX
      add esi, eax
      inc ebx
    .ENDW
    push esi
    fild DWORD PTR [esp]
    fld8 1000000.0
    fdiv
    fstp error
    pop eax
    invoke crt_printf, chr$("mean absolute error 0-999999: %f%c%c"),
                       error, 10, 10

    xor esi, esi
    xor ebx, ebx
    .WHILE ebx < 10000000
      invoke UMGetSqrt, ebx
      push eax
      invoke fisqrt, ebx
      pop edx
      sub eax, edx
      AbsEAX
      add esi, eax
      inc ebx
    .ENDW
    push esi
    fild DWORD PTR [esp]
    fld8 10000000.0
    fdiv
    fstp error
    pop eax
    invoke crt_printf, chr$("mean absolute error 0-9999999: %f%c%c"),
                       error, 10, 10

    xor esi, esi
    xor ebx, ebx
    .WHILE ebx < 100000000
      invoke UMGetSqrt, ebx
      push eax
      invoke fisqrt, ebx
      pop edx
      sub eax, edx
      AbsEAX
      add esi, eax
      inc ebx
    .ENDW
    push esi
    fild DWORD PTR [esp]
    fld8 100000000.0
    fdiv
    fstp error
    pop eax
    invoke crt_printf, chr$("mean absolute error 0-99999999: %f%c%c"),
                       error, 10, 10

    inkey
    print chr$(13,10)

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke UMGetSqrt, 123456
    counter_end
    print ustr$(eax)," cycles, UMGetSqrt",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke fisqrt, 123456
    counter_end
    print ustr$(eax)," cycles, fisqrt",13,10,13,10

    free sqrt_tbl
    inkey "Press any key to exit..."
    exit
; 
end start
 